#include "plot.h"

#include <QtDebug>

//как правильнос ставить layout
//°C didn't work properly

int step = 25;
int xOffset = 0;
int graphHeight = 300;
bool working = true;
int R = 3;
int lineN = 0;

Plot::Plot()
{
    x1=0;
    x2=0;
    y1=0;
    y2=0;

    linesList = new QList<QLineF *> ;

    tLabel = new QLabel("Temperature = 0",this);

    qsrand(QDateTime::currentDateTime().toTime_t());

    button = new QPushButton("Button");
    connect(button,SIGNAL(clicked()),this,SLOT(timerStopStart()));
    button->setText("Stop");

    drawTimer = new QTimer(this);
    connect(drawTimer,SIGNAL(timeout()),this,SLOT(on_timer()));

    graphicsView = new QGraphicsView(this);
    //graphicsView->setFixedSize(550,graphHeight+20);
    graphicsView->setFixedHeight(graphHeight+20);
    //graphicsView->horizontalScrollBar()->setHidden(true);
    graphicsView->setHorizontalScrollBarPolicy(Qt::ScrollBarAlwaysOn);
    graphicsView->setVerticalScrollBarPolicy(Qt::ScrollBarAlwaysOff);
    graphicsView->verticalScrollBar()->setHidden(true);
    //graphicsView->setDragMode(QGraphicsView::ScrollHandDrag);
    graphicsView->setRenderHint(QPainter::Antialiasing, true);
    graphicsView->viewport()->setMouseTracking(true);
    graphicsView->viewport()->installEventFilter(this);

    QGridLayout *layout = new QGridLayout;
    layout->addWidget(graphicsView,0,0,1,20);
    layout->setRowStretch(2,10);
    layout->addWidget(tLabel,3,0,1,20);
    layout->addWidget(button,4,0,1,20);
    QWidget *widget = new QWidget(this);
    widget->setLayout(layout);
    setCentralWidget(widget);

    scene = new QGraphicsScene();
    graphicsView->setScene(scene);
    scene->setSceneRect(0,0,550,graphHeight);

    QPen rpen(Qt::red, 2.0);
    vLine = new QGraphicsLineItem;
    vLine->setLine(0,0,0,scene->height());
    vLine->setPen(rpen);
    scene->addItem(vLine);



    drawTimer->start(100);
}

bool Plot::eventFilter(QObject *obj, QEvent *event)
{
    if (event->type() == QEvent::MouseMove)
    {
        QMouseEvent *mEvent = static_cast<QMouseEvent*>(event);
        int x = mEvent->pos().x()+graphicsView->horizontalScrollBar()->value();
        vLine->setPos(x,0);

        int pos;
        pos = vLine->x()/step;

        if (linesList->count()>pos)
        {
            QLineF* line1 = new QLineF(linesList->at(pos)->x1(), linesList->at(pos)->y1(),
                                       linesList->at(pos)->x2(), linesList->at(pos)->y2());
            QLineF line2(vLine->x(), 0, vLine->x(), scene->height());
            QPointF intersectionPoint;
            line1->intersect(line2, &intersectionPoint);
            if (vLine->x()>=linesList->at(pos)->x1() && vLine->x()<=linesList->at(pos)->x2() && scene->height()-intersectionPoint.y()!=0)
            {
                // manual
                //tLabel->setText("Temperature = "+QString::number(scene->height()-intersectionPoint.y()));
                // integer
                tLabel->setText("Temperature = "+QString::number(scene->height()-(int)intersectionPoint.y()));
            }
        }
        else
            tLabel->setText("Temperature = 0");
        return true;
    }
    else
        return false;
    return QMainWindow::eventFilter(obj, event);
}

void Plot::timerStopStart()
{
    if (working)
    {
        drawTimer->stop();
        button->setText("Start");
        working = false;
    }
    else
    {
        drawTimer->start();
        button->setText("Stop");
        working = true;
    }
}

void Plot::on_timer()
{
    // line drawing
    QPen pen(Qt::black, 2.0);
    QBrush brush(QColor::fromRgb(255, 0, 0));

    x2 = x1+step;
    y2 = qrand()%graphHeight;

    linesList->append(new QLineF(x1,y1,x2,y2));
    scene->addLine(*linesList->at(lineN),pen);
    scene->addEllipse(x1-R,y1-R,R*2,R*2,pen,brush);

    x1 = x2;
    y1 = y2;

    // scrolling
    if ((x2-xOffset)>graphicsView->width()/2)
    {
        graphicsView->horizontalScrollBar()->setValue(graphicsView->horizontalScrollBar()->value()+step);
        xOffset+=step;

        //start scroll at middle
        scene->setSceneRect(0,0,scene->width()+step,graphHeight);
    }

    if (scene->width()==x2)
        scene->setSceneRect(0,0,scene->width()+step,graphHeight);

    lineN++;

    QCursor *cursor = new QCursor;
    cursor->setPos(cursor->pos().x(),cursor->pos().y()+1);
    cursor->setPos(cursor->pos().x(),cursor->pos().y()-1);
}


void Plot::resizeEvent(QResizeEvent *)
{
    if (scene->width()<graphicsView->width()) scene->setSceneRect(0,0,graphicsView->width()*1.5,graphHeight);
    graphicsView->horizontalScrollBar()->setValue(graphicsView->horizontalScrollBar()->maximum());

    //if (scene->width()-xOffset>graphicsView->width()/2)
    //    scene->setSceneRect(0,0,xOffset+graphicsView->width()/2,graphHeight);
    if (scene->width()-linesList->count()*step<graphicsView->width()/2)
    {
        scene->setSceneRect(0,0,linesList->count()*step+graphicsView->width()/2,graphHeight);
        graphicsView->horizontalScrollBar()->setValue(graphicsView->horizontalScrollBar()->maximum());
    }

    //qDebug()<<"linesList->count()*step"<<linesList->count()*step;
    //qDebug()<<"graphicsView->width()/2"<<graphicsView->width()/2;
    //qDebug()<<"scene->width()-linesList->count()*step"<<scene->width()-linesList->count()*step;
}
