#ifndef PLOT_H
#define PLOT_H

#include <QtGui>
#include <QMainWindow>

class Plot : public QMainWindow
{
     Q_OBJECT

public:
     Plot();

protected:
     bool eventFilter(QObject *obj, QEvent *ev);

private:
     int x1;
     int x2;
     int y1;
     int y2;

     QTimer* drawTimer;
     QList<QLineF *> *linesList;
     QLabel *tLabel;
     QGraphicsView *graphicsView;
     QGraphicsLineItem *vLine;
     QPushButton *button;
     QGraphicsScene *scene;

private slots:
     void on_timer();
     void timerStopStart();
     void resizeEvent(QResizeEvent *);
};

#endif // PLOT_H
